﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TestScheduleView
{
    public class AppointmentBO
    {
        public string Calendar { get; set; }
        public string Category { get; set; }
        public string Resource { get; set; }
        public DateTime Start { get; set; }
        public DateTime End { get; set; }
        private byte[] _rawData;

        public static IEnumerable<AppointmentBO> Generate(string resource, string calendar)
        {
            DateTime startTime = DateTime.Today.AddHours(8);
            DateTime next = startTime;

            for (int i = 0; i < 20; i++)
            {                
                string category = GenerateBrush();

                DateTime start = GenerateStart(next);
                DateTime end = GenerateEnd(start);
                next = end;
                byte[] rawData = GenerateRawData();

                AppointmentBO appointment = new AppointmentBO()
                {
                    End=end,
                    Start=start,
                    Calendar=calendar,
                    Category=category,
                    Resource=resource,
                    _rawData = rawData
                };

                yield return appointment;
            }
        }

        private static string GenerateBrush()
        {
            Thread.Sleep(1);
            Random random = new Random(DateTime.Now.Millisecond);

            return string.Format("Brush{0}", random.Next(0, 7));
        }

        private static DateTime GenerateStart(DateTime next)
        {
            Thread.Sleep(1);
            Random random = new Random(DateTime.Now.Millisecond);

            int minutesToAdd = random.Next(5, 15);

            return next.AddMinutes(minutesToAdd);
        }

        private static DateTime GenerateEnd(DateTime start)
        {
            Thread.Sleep(1);
            Random random = new Random(DateTime.Now.Millisecond);

            int minutesToAdd = random.Next(20, 40);

            return start.AddMinutes(minutesToAdd);
        }

        private static byte[] GenerateRawData()
        {
            // 10 kb 
            int size = 10240;

            byte[] result = new byte[size];

            for (int i = 0; i < size; i++)
                result[i] = 1;

            return result;
        }
    }
}
